// ChatStatusWnd.cpp :  Դϴ.
//

#include "stdafx.h"
#include "NeMessenger.h"
#include "ChatStatusWnd.h"

// CChatStatusWnd

IMPLEMENT_DYNAMIC(CChatStatusWnd, CWnd)

CChatStatusWnd::CChatStatusWnd()
{
	// BG
	m_pImgBG = NULL;

	m_crBG = DEF_BG_COLOR;

	m_rtWnd.SetRectEmpty();
	m_rtStatusText.SetRectEmpty();

	// font
	_tcsncpy(m_wszFontName, L"", _countof(m_wszFontName) - 1);
	m_nFontHeight = 10;
	m_fontStyle = FontStyleRegular;
	m_crText = DEF_TEXT_COLOR;

	// attribute
	m_strStatusText = _T("");
	m_strStatusTextAbbr = _T("");
}

CChatStatusWnd::~CChatStatusWnd()
{
    ASSERT(NULL == m_pImgBG);

    //fix lint 1540
    SAFE_DELETE(m_pImgBG);
}

BEGIN_MESSAGE_MAP(CChatStatusWnd, CWnd)
	ON_WM_CREATE()
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_DESTROY()
END_MESSAGE_MAP()

void CChatStatusWnd::SetImgBGPath(CString strFileName)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgBG = new Image(strImgPath);
}

void CChatStatusWnd::SetFontConfig(WCHAR* wszFontName, REAL nFontHeight, FontStyle style, Color crText)
{
	_tcsncpy(m_wszFontName, wszFontName, _countof(m_wszFontName) - 1);
	m_nFontHeight = nFontHeight;
	m_fontStyle = style;

	m_crText = crText;
}

void CChatStatusWnd::SetStatusText(CString strStatus)
{
	m_strStatusText = strStatus;

	if (!m_rtStatusText.IsRectEmpty())
	{
		m_strStatusTextAbbr = RecalcTextString(this, m_strStatusText, m_wszFontName, m_nFontHeight, m_fontStyle, m_rtStatusText);		
	}

	RedrawWindow(&m_rtStatusText, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

// CChatStatusWnd ޽ óԴϴ.

int CChatStatusWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	return 0;
}

void CChatStatusWnd::OnDestroy()
{
    SAFE_DELETE(m_pImgBG);
	CWnd::OnDestroy();
}

BOOL CChatStatusWnd::OnEraseBkgnd(CDC* pDC)
{
	return TRUE;
}

void CChatStatusWnd::OnPaint()
{
	CPaintDC dc(this);

	PAINTSTRUCT ps = dc.m_ps;
	int psWidth = ps.rcPaint.right - ps.rcPaint.left;
	int psHeight = ps.rcPaint.bottom - ps.rcPaint.top;

	int nPX = ps.rcPaint.left;
	int nPY = ps.rcPaint.top;

	CRect rtPS(nPX, nPY, nPX + psWidth, nPY + psHeight);

	CRect rt(0, 0, 0, 0);
	GetClientRect(&rt);
	//int nWndWidth = rt.Width();
	//int nWndHeight = rt.Height();

	HDC hdc = dc.GetSafeHdc();

	HDC	hdcMemory = CreateCompatibleDC(hdc);

	if (hdcMemory == NULL)
		return;

	HBITMAP hbmpMem = CreateCompatibleBitmap(hdc, psWidth, psHeight);

	HGDIOBJ hbmpOld = ::SelectObject(hdcMemory,  hbmpMem);

	Graphics graph(hdcMemory);

	if (hbmpMem)
	{
		graph.SetSmoothingMode(SmoothingModeAntiAlias);
		graph.SetPageUnit(UnitPixel);

		ImageAttributes ImgAttr;

        if (m_pImgBG){
			DrawImageToStretchHorz(&graph, m_pImgBG, &rtPS, &m_rtWnd, Color(255, 160, 163, 169), &ImgAttr);
        }
		else
		{
			SolidBrush brushBG(m_crBG);			
			Pen penBG(m_crBG, 1);

			graph.FillRectangle(&brushBG, nPX, nPY, psWidth, psHeight);
			graph.DrawRectangle(&penBG, nPX, nPY, psWidth, psHeight);
		}

		if (!m_strStatusTextAbbr.IsEmpty())
		{
			CRect rtStatusText = m_rtStatusText;
			rtStatusText.InflateRect(0, 0, 10, 0);
			rtStatusText.top += DEF_STATUS_TEXT_REL_POS_TOP;
			DrawTextToDest2(&graph,
							m_strStatusTextAbbr, &rtPS, &rtStatusText,
							m_wszFontName, m_nFontHeight,
							StringAlignmentNear,
							m_fontStyle,
							m_crText);
		}

		BitBlt(dc.GetSafeHdc(), nPX, nPY, psWidth, psHeight, hdcMemory, 0, 0, SRCCOPY);

		::SelectObject(hdcMemory, hbmpOld);
		::DeleteObject(hbmpMem);
	}

	::DeleteDC(hdcMemory);
}

void CChatStatusWnd::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	m_rtWnd.SetRect(0, 0, cx, cy);

	int nLimitWidth = m_rtWnd.Width() - (DEF_STATUS_REL_POS_LEFT + DEF_STATUS_REL_POS_RIGHT);
	CRect rtBound(0, 0, nLimitWidth, 500);

	CSize szStatus(0, 0);
	int nSX = DEF_STATUS_REL_POS_LEFT, nSY = 0, nCX = nLimitWidth, nCY = cy;
	if (!m_strStatusText.IsEmpty())
	{
		m_strStatusTextAbbr = RecalcTextString(this, m_strStatusText, m_wszFontName, m_nFontHeight, m_fontStyle, rtBound);

		RecalcTextRect(this, m_strStatusTextAbbr, m_wszFontName, m_nFontHeight, m_fontStyle, rtBound, szStatus);

		nCY = szStatus.cy;
		nSY = (cy - nCY) / 2;
	}	
	
	m_rtStatusText.SetRect(nSX, 0, nSX + nCX, nSY + nCY);
}
